## s390-tools 2.38.0

=== Makefile ===
# Include common definitions
include common.mak

#
# BASELIBS: Libraries that have no dependency to other libraries in s390-tools
# LIBS: Libraries that can have a dependency to base libraries
# TOOLS: Tools that can have a dependency to base libraries or libraries
#
ifeq ($(HOST_ARCH),s390x)
BASELIB_DIRS = libutil libseckey
LIB_DIRS = libvtoc libzds libdasd libccw libvmcp libekmfweb \
	   libkmipclient libcpumf libap libpv libzpci
TOOL_DIRS = zipl zdump fdasd dasdfmt dasdview tunedasd \
	   tape390 osasnmpd qetharp ip_watcher qethconf scripts zconf \
	   vmcp man mon_tools dasdinfo vmur cpuplugd ipl_tools \
	   ziomon iucvterm hyptop cmsfs-fuse qethqoat zfcpdump zdsfs cpumf \
	   systemd hmcdrvfs cpacfstats zdev dump2tar zkey netboot etc zpcictl \
	   lsstp hsci hsavmcore chreipl-fcp-mpath ap_tools rust opticsmon \
	   zpwr zmemtopo

else
BASELIB_DIRS =
LIB_DIRS = libpv
TOOL_DIRS = rust
endif

SUB_DIRS = $(BASELIB_DIRS) $(LIB_DIRS) $(TOOL_DIRS)

all: $(TOOL_DIRS)
clean: $(TOOL_DIRS)
install: $(TOOL_DIRS)

#
# For simple "make" we explicitly set the MAKECMDGOALS to "all".
#
ifeq ($(MAKECMDGOALS),)
MAKECMDGOALS = all
endif

#
# We have to build the base libraries before the other libraries are built,
# and then build the other libraries before the tools are built. Otherwise the
# other libraries and tools would trigger parallel "make -C" builds for the
# base libraries and the other libraries in case of "make -j".
#
# MAKECMDGOALS contains the list of goals, e.g. "clean all". We use
# "foreach" to generate a ";" separated list of "make -C <target>".
# For example the the expansion for "make clean all" is:
#
# $(MAKE) -C $@ [..] clean ;  $(MAKE) -C $@ [...] all ;
#
# This ensures that the commandline targets are serialized and also "make -j"
# works as expected, e.g. "make clean all -j 20".
#

$(TOOL_DIRS): $(LIB_DIRS)
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
.PHONY: $(TOOL_DIRS)

$(LIB_DIRS): $(BASELIB_DIRS)
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
.PHONY: $(LIB_DIRS)

$(BASELIB_DIRS):
	$(foreach goal,$(MAKECMDGOALS), \
		$(MAKE) -C $@ TOPDIR=$(TOPDIR) HOST_ARCH=$(HOST_ARCH) $(goal) ;)
.PHONY: $(BASELIB_DIRS)

=== etc/Makefile ===
include ../common.mak

CONFIG_FILES =

ifneq (${SYSTEMDSYSTEMUNITDIR},)
CONFIG_FILES += cpuplugd.conf sysconfig/cpi sysconfig/dumpconf \
                sysconfig/mon_fsstatd sysconfig/mon_procd
endif

install:
	for file in $(CONFIG_FILES); do \
		$(INSTALL) -g $(GROUP) -o $(OWNER) \
			   -m 644 $$file $(DESTDIR)$(SYSCONFDIR)/$$file ; \
	done

.PHONY: all install clean

=== hmcdrvfs/Makefile ===
#!/usr/bin/make -f

include ../common.mak

ifeq (${HAVE_FUSE},0)

all:
	$(SKIP) HAVE_FUSE=0

install:
	$(SKIP) HAVE_FUSE=0

else

check_dep:
	$(call check_dep, \
		"hmcdrvfs", \
		"fuse.h", \
		"fuse3-devel or libfuse3-dev", \
		"HAVE_FUSE=0")

FUSE_CFLAGS = $(shell $(PKG_CONFIG) --silence-errors --cflags fuse3)
FUSE_LDLIBS = $(shell $(PKG_CONFIG) --silence-errors --libs fuse3)
ALL_CFLAGS += -DFUSE_USE_VERSION=30 -D_LARGEFILE_SOURCE $(FUSE_CFLAGS)
LDLIBS += $(FUSE_LDLIBS) -lpthread -lrt -ldl -lm

OBJECTS = hmcdrvfs.o

libs = $(rootdir)/libutil/libutil.a

all: check_dep hmcdrvfs

$(OBJECTS): Makefile

hmcdrvfs: $(OBJECTS) $(libs)

install: all install-scripts
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 hmcdrvfs \
		$(DESTDIR)$(USRBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 hmcdrvfs.1 \
		$(DESTDIR)$(MANDIR)/man1
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 lshmc.8 \
		$(DESTDIR)$(MANDIR)/man8

install-scripts: lshmc
	@for i in $^; do \
		cat $$i | \
		sed -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' \
		>$(DESTDIR)$(USRSBINDIR)/$$i; \
		chown $(OWNER):$(GROUP) $(DESTDIR)$(USRSBINDIR)/$$i; \
		chmod 755 $(DESTDIR)$(USRSBINDIR)/$$i; \
	done

endif

clean:
	rm -f hmcdrvfs *.o

.PHONY: all install install-scripts clean check_dep

=== hsavmcore/Makefile ===
#
# Copyright IBM Corp. 2021
#
# s390-tools is free software; you can redistribute it and/or modify
# it under the terms of the MIT license. See LICENSE for details.
#

include ../common.mak

ALL_CPPFLAGS += -D_FILE_OFFSET_BITS=64

ifeq (${HAVE_FUSE},0)

all:
	$(SKIP) HAVE_FUSE=0

install:
	$(SKIP) HAVE_FUSE=0

else # HAVE_FUSE

#
# FUSE
#
FUSE_CFLAGS = $(shell $(PKG_CONFIG) --silence-errors --cflags fuse3)
FUSE_LDLIBS = $(shell $(PKG_CONFIG) --silence-errors --libs fuse3)

#
# systemd
#
ifneq (${HAVE_SYSTEMD},0)
  ifeq ($(call check_header_prereq,"systemd/sd-daemon.h"),yes)
    SYSTEMD_CFLAGS = $(shell $(PKG_CONFIG) --silence-errors --cflags libsystemd)
    SYSTEMD_LDLIBS = $(shell $(PKG_CONFIG) --silence-errors --libs libsystemd)
    ALL_CPPFLAGS += -DHAVE_SYSTEMD
  else
    $(warning "systemd support disabled")
  endif
endif

ALL_CFLAGS += $(FUSE_CFLAGS) $(SYSTEMD_CFLAGS)
LDLIBS += $(FUSE_LDLIBS) $(SYSTEMD_LDLIBS) -lpthread

sources := $(wildcard *.c)
objects := $(patsubst %.c,%.o,$(sources))

libs = $(rootdir)/libutil/libutil.a

all: hsavmcore

hsavmcore: $(objects) $(libs)
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@

overlay.o: check-dep-fuse overlay.c overlay.h

check-dep-fuse:
	$(call check_dep, \
		"hsavmcore", \
		"fuse.h", \
		"fuse3-devel or libfuse3-dev", \
		"HAVE_FUSE=0", \
		"-DFUSE_USE_VERSION=30")
	touch check-dep-fuse

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 hsavmcore \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/hsavmcore.8 \
		$(DESTDIR)$(MANDIR)/man8
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/hsavmcore.conf.5 \
		$(DESTDIR)$(MANDIR)/man5

endif # HAVE_FUSE

clean:
	rm -f hsavmcore $(objects) check-dep-fuse

.PHONY: all install clean

=== hyptop/Makefile ===
include ../common.mak

ifeq (${HAVE_NCURSES},0)

all:
	$(SKIP) HAVE_NCURSES=0

install:
	$(SKIP) HAVE_NCURSES=0

else

check_dep:
	$(call check_dep, \
		"hyptop", \
		"ncurses.h", \
		"ncurses-devel or libncurses-dev", \
		"HAVE_NCURSES=0")

LDLIBS += -lncurses

all: check_dep hyptop

OBJECTS = hyptop.o opts.o helper.o \
	  sd_core.o sd_sys_items.o sd_cpu_items.o \
	  tbox.o table.o table_col_unit.o \
	  dg_debugfs.o dg_debugfs_lpar.o dg_debugfs_vm.o dg_debugfs_vmd0c.o \
	  win_sys_list.o win_sys.o win_fields.o \
	  win_cpu_types.o win_help.o nav_desc.o

hyptop: $(OBJECTS) $(rootdir)/libutil/libutil.a

install: all
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 hyptop \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 hyptop.8 \
		$(DESTDIR)$(MANDIR)/man8

endif

clean:
	rm -f *.o *~ hyptop core

.PHONY: all install clean check_dep

=== ip_watcher/Makefile ===
include ../common.mak

all: xcec-bridge

libs =	$(rootdir)/libutil/libutil.a

xcec-bridge: xcec-bridge.o $(libs)

clean:
	rm -f *.o core xcec-bridge

install: ip_watcher.pl xcec-bridge start_hsnc.sh
	$(SED) -e 's/%S390_TOOLS_VERSION%/$(S390_TOOLS_RELEASE)/' \
	< start_hsnc.sh >$(DESTDIR)$(USRSBINDIR)/start_hsnc.sh; \
	chown $(OWNER):$(GROUP) $(DESTDIR)$(USRSBINDIR)/start_hsnc.sh; \
	chmod 755 $(DESTDIR)$(USRSBINDIR)/start_hsnc.sh; \
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ip_watcher.pl \
		$(DESTDIR)$(USRSBINDIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 xcec-bridge \
		$(DESTDIR)$(USRSBINDIR)

.PHONY: all install clean

=== iucvterm/Makefile ===
#! /usr/bin/make -f

include ../common.mak


GETTEXT_TEXTDOMAIN = iucvterm
export GETTEXT_TEXTDOMAIN


SUBDIRS = src po doc bin etc test
RECURSIVE_TARGETS = all-recursive install-recursive clean-recursive \
                    check-recursive


all: all-recursive
install: install-recursive
clean: clean-recursive


$(RECURSIVE_TARGETS):
	@target=`echo $@ |sed s/-recursive//`; \
	for d in $(SUBDIRS); do \
		(cd $$d && $(MAKE) $$target) || exit 1; \
	done


.PHONY: install clean

=== libcpumf/Makefile ===
include ../common.mak

lib = libcpumf.a

examples = libcpumf_example

all: $(lib)
examples: $(lib) $(examples)

objects = libcpumf_pmutype.o libcpumf_cpuset.o libcpumf_support.o \
	  libcpumf_ctrset.o

$(lib): $(objects)

install: all

libcpumf_example: libcpumf_example.o $(lib) $(rootdir)/libutil/libutil.a

clean:
	rm -f *.o $(lib) $(examples)

=== libkmipclient/Makefile ===
include ../common.mak

VERSION = 1.0
VERM = $(shell echo $(VERSION) | cut -d '.' -f 1)

ifneq (${HAVE_OPENSSL},0)
	ifneq (${HAVE_JSONC},0)
		ifneq (${HAVE_LIBXML2},0)
			ifneq (${HAVE_LIBCURL},0)
				BUILD_TARGETS += libkmipclient.so.$(VERSION)
				INSTALL_TARGETS += install-libkmipclient.so.$(VERSION)
			else
				BUILD_TARGETS += skip-libkmipclient-curl
				INSTALL_TARGETS += skip-libkmipclient-curl
			endif
		else
			BUILD_TARGETS += skip-libkmipclient-xml
			INSTALL_TARGETS += skip-libkmipclient-xml
		endif
	else
		BUILD_TARGETS += skip-libkmipclient-jsonc
		INSTALL_TARGETS += skip-libkmipclient-jsonc
	endif
else
	BUILD_TARGETS += skip-libkmipclient-openssl
	INSTALL_TARGETS += skip-libkmipclient-openssl
endif

TMPFILE := $(shell mktemp)

detect-openssl-version.dep:
	echo "#include <openssl/opensslv.h>" > $(TMPFILE)
	echo "#include <openssl/evp.h>" >> $(TMPFILE)
	echo "#ifndef OPENSSL_VERSION_PREREQ" >> $(TMPFILE)
	echo "  #if defined(OPENSSL_VERSION_MAJOR) && defined(OPENSSL_VERSION_MINOR)" >> $(TMPFILE)
	echo "    #define OPENSSL_VERSION_PREREQ(maj, min) \\" >> $(TMPFILE)
	echo "                 ((OPENSSL_VERSION_MAJOR << 16) + \\" >> $(TMPFILE)
	echo "                  OPENSSL_VERSION_MINOR >= ((maj) << 16) + (min))" >> $(TMPFILE)
	echo "  #else" >> $(TMPFILE)
	echo "    #define OPENSSL_VERSION_PREREQ(maj, min) \\" >> $(TMPFILE)
	echo "                 (OPENSSL_VERSION_NUMBER >= (((maj) << 28) | \\" >> $(TMPFILE)
	echo "		        ((min) << 20)))" >> $(TMPFILE)
	echo "  #endif" >> $(TMPFILE)
	echo "#endif" >> $(TMPFILE)
	echo "#if !OPENSSL_VERSION_PREREQ(1, 1)" >> $(TMPFILE)
	echo "  #error openssl version 1.1 is required" >> $(TMPFILE)
	echo "#endif" >> $(TMPFILE)
	echo "static void __attribute__((unused)) test(void) {" >> $(TMPFILE)
	echo "    EVP_PKEY_meth_remove(NULL);" >> $(TMPFILE)
	echo "}" >> $(TMPFILE)
	mv $(TMPFILE) $@

CURL_CONFIG ?= curl-config

check-dep-libkmipclient: detect-openssl-version.dep
	$(call check_dep, \
		"libkmipclient", \
		"detect-openssl-version.dep", \
		"openssl-devel version >= 1.1.1", \
		"HAVE_OPENSSL=0", \
		-I. `$(PKG_CONFIG) --cflags --libs libcrypto` -DOPENSSL_SUPPRESS_DEPRECATED)
	$(call check_dep, \
		"libkmipclient", \
		"json-c/json.h", \
		"json-c-devel", \
		"HAVE_JSONC=0")
	$(call check_dep, \
		"libkmipclient", \
		"libxml/tree.h", \
		"libxml2-devel", \
		"HAVE_LIBXML2=0", \
		`$(PKG_CONFIG) --cflags --libs libxml-2.0`)
	$(call check_dep, \
		"libkmipclient", \
		"curl/curl.h", \
		"libcurl-devel", \
		"HAVE_LIBCURL=0" \
		`$(PKG_CONFIG) --cflags --libs libcurl`)
	$(CURL_CONFIG) --ssl-backends | grep OpenSSL >/dev/null 2>&1 || { echo "Error: libcurl is not built with the OpenSSL backend"; exit 1; }
	touch check-dep-libkmipclient

skip-libkmipclient-openssl:
	echo "  SKIP    libkmipclient due to HAVE_OPENSSL=0"

skip-libkmipclient-jsonc:
	echo "  SKIP    libkmipclient due to HAVE_JSONC=0"

skip-libkmipclient-xml:
	echo "  SKIP    libkmipclient due to HAVE_LIBXML2=0"

skip-libkmipclient-curl:
	echo "  SKIP    libkmipclient due to HAVE_LIBCURL=0"

all: $(BUILD_TARGETS)

kmip.o: check-dep-libkmipclient kmip.c kmip.h utils.h $(rootdir)include/kmipclient/kmipclient.h
request.o: check-dep-libkmipclient request.c kmip.h names.h $(rootdir)include/kmipclient/kmipclient.h
response.o: check-dep-libkmipclient response.c kmip.h names.h $(rootdir)include/kmipclient/kmipclient.h
attribute.o: check-dep-libkmipclient attribute.c kmip.h names.h $(rootdir)include/kmipclient/kmipclient.h
key.o: check-dep-libkmipclient key.c kmip.h names.h $(rootdir)include/kmipclient/kmipclient.h
ttlv.o: check-dep-libkmipclient ttlv.c kmip.h utils.h $(rootdir)include/kmipclient/kmipclient.h
json.o: check-dep-libkmipclient json.c kmip.h names.h utils.h $(rootdir)include/kmipclient/kmipclient.h
xml.o: check-dep-libkmipclient xml.c kmip.h names.h utils.h $(rootdir)include/kmipclient/kmipclient.h
https.o: check-dep-libkmipclient https.c kmip.h utils.h $(rootdir)include/kmipclient/kmipclient.h
tls.o: check-dep-libkmipclient tls.c kmip.h utils.h $(rootdir)include/kmipclient/kmipclient.h
names.o: check-dep-libkmipclient names.c names.h utils.h $(rootdir)include/kmipclient/kmipclient.h
utils.o: check-dep-libkmipclient utils.c names.h utils.h $(rootdir)include/kmipclient/kmipclient.h

libkmipclient.so.$(VERSION): ALL_CFLAGS += -fPIC `$(PKG_CONFIG) --cflags json-c libcrypto libssl libxml-2.0 libcurl`
libkmipclient.so.$(VERSION): LDLIBS = `$(PKG_CONFIG) --libs json-c libcrypto libssl libxml-2.0 libcurl`
libkmipclient.so.$(VERSION): ALL_LDFLAGS += -shared -Wl,--version-script=libkmipclient.map \
	-Wl,-z,defs,-Bsymbolic -Wl,-soname,libkmipclient.so.$(VERM)
libkmipclient.so.$(VERSION): kmip.o request.o response.o attribute.o key.o ttlv.o json.o \
	xml.o https.o tls.o names.o utils.o
	$(LINK) $(ALL_LDFLAGS) $^ $(LDLIBS) -o $@
	ln -srf libkmipclient.so.$(VERSION) libkmipclient.so.$(VERM)
	ln -srf libkmipclient.so.$(VERSION) libkmipclient.so

install-libkmipclient.so.$(VERSION): libkmipclient.so.$(VERSION)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 -T libkmipclient.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libkmipclient.so.$(VERSION)
	ln -srf $(DESTDIR)$(SOINSTALLDIR)/libkmipclient.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libkmipclient.so.$(VERM)
	ln -srf $(DESTDIR)$(SOINSTALLDIR)/libkmipclient.so.$(VERSION) $(DESTDIR)$(SOINSTALLDIR)/libkmipclient.so
	$(INSTALL) -d -m 755 $(DESTDIR)$(USRINCLUDEDIR)/kmipclient
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 $(rootdir)include/kmipclient/kmipclient.h $(DESTDIR)$(USRINCLUDEDIR)/kmipclient

install: all $(INSTALL_TARGETS)

clean:
	rm -f *.o libkmipclient.so* check-dep-libkmipclient detect-openssl-version.dep

.PHONY: all install clean skip-libkmipclient-openssl skip-libkmipclient-jsonc \
	skip-libkmipclient-xml skip-libkmipclient-curl install-libkmipclient.so.$(VERSION)

=== libpv/Makefile ===
# Common definitions
include ../common.mak

.DEFAULT_GOAL := all

LIB := libpv.a

GLIB2_CFLAGS := $(shell $(PKG_CONFIG) --silence-errors --cflags glib-2.0)
GLIB2_LIBS := $(shell $(PKG_CONFIG) --silence-errors --libs glib-2.0)
LIBCRYPTO_CFLAGS := $(shell $(PKG_CONFIG) --silence-errors --cflags libcrypto)
LIBCRYPTO_LIBS := $(shell $(PKG_CONFIG) --silence-errors --libs libcrypto)
LDLIBS += $(GLIB2_LIBS) $(LIBCRYPTO_LIBS)
WARNINGS := -Wall -Wextra -Wshadow \
	    -Wcast-align -Wwrite-strings -Wmissing-prototypes \
	    -Wmissing-declarations -Wredundant-decls -Wnested-externs \
	    -Wno-long-long -Wuninitialized -Wconversion -Wstrict-prototypes \
	    -Wpointer-arith -Wno-error=inline \
	    -Wno-unused-function -Wno-unused-parameter -Wno-unused-variable \
	    $(NULL)

ALL_CFLAGS += -DOPENSSL_API_COMPAT=0x10101000L \
	      $(GLIB2_CFLAGS) \
	      $(LIBCRYPTO_CFLAGS) \
	      $(WARNINGS) \
	      $(NULL)

BUILD_TARGETS := skip-$(LIB)
ifneq (${HAVE_OPENSSL},0)
ifneq (${HAVE_GLIB2},0)
BUILD_TARGETS := $(LIB)
endif
endif

sources := $(wildcard *.c)
objects := $(patsubst %.c,%.o,$(sources))

all: $(BUILD_TARGETS)

$(LIB): $(objects)
$(LIB): ALL_CFLAGS += -fPIC

$(objects): .check-dep-$(LIB)

install: all

clean:
	rm -f -- $(objects)
	rm -f -- $(LIB)
	rm -f -- .check-dep-$(LIB) .detect-openssl.dep.c

skip-$(LIB):
		echo "  SKIP    $(LIB) due to unresolved dependencies"

.PHONY: all install clean skip-$(LIB) install-$(LIB)


.detect-openssl.dep.c:
	echo "#include <openssl/evp.h>" > $@
	echo "#if OPENSSL_VERSION_NUMBER < 0x10101000L" >> $@
	echo "  #error openssl version 1.1.1 is required" >> $@
	echo "#endif" >> $@
	echo "static void __attribute__((unused)) test(void) {" >> $@
	echo "    EVP_MD_CTX *ctx = EVP_MD_CTX_new();" >> $@
	echo "    EVP_MD_CTX_free(ctx);" >> $@
	echo "}" >> $@

.check-dep-$(LIB): .detect-openssl.dep.c
	$(call check_dep, \
		"$(LIB)", \
		"glib.h", \
		"glib2-devel / libglib2.0-dev", \
		"HAVE_GLIB2=0")
	$(call check_dep, \
		"$(LIB)", \
		$^, \
		"openssl-devel / libssl-dev version >= 1.1.1", \
		"HAVE_OPENSSL=0", \
		"-I.")
	touch $@

=== libvtoc/Makefile ===
include ../common.mak

lib = libvtoc.a

all: $(lib)

objects = vtoc.o

$(lib): $(objects)

install: all

clean:
	rm -f *.o $(lib)

=== libzpci/Makefile ===
include ../common.mak

lib = libzpci.a

all: $(lib)

objects = pci_list.o pci_sclp.o

examples := $(patsubst %.c,%,$(wildcard *_example.c))

examples: $(examples)
$(examples): %: %.o $(lib) $(rootdir)/libutil/libutil.a

$(lib): ALL_CFLAGS += -fPIC -std=c11
$(lib): $(objects)

install: all

clean:
	rm -f *.o $(lib) $(examples)

=== debian/changelog ===
s390-tools (2.38.0-0ubuntu3) questing; urgency=medium

  * Add d/p/lp-2118866-cpi-Disable-CPI-for-SEL-guests-by-default.patch to
    allow the cpictl utility to not automatically send CPI data if the Linux
    instance runs a Secure Execution guest (LP: #2118866).

 -- Frank Heimes <frank.heimes@canonical.com>  Thu, 31 Jul 2025 08:28:39 +0200

s390-tools (2.38.0-0ubuntu2) questing; urgency=medium

  * Move stage3*.* boot-loader files in d/s390-tools-data.install from
    pvimg/boot folder on up to pvimg, otherwise pvimg cannot find them
    (LP: #2118762).

 -- Frank Heimes <frank.heimes@canonical.com>  Fri, 25 Jul 2025 12:20:55 +0200

s390-tools (2.38.0-0ubuntu1) questing; urgency=medium

  * New upstream release. (LP: #2115416)
    - Modify d/p/conformance-to-dep17-usr-merge.patch due to context change
      and expand it to cover more cases.
    - Update XS-Vendored-Sources-Rust field in d/control with new/different
      crates/versions.
    - Update d/p/vendor-remove-unused-deps.patch to reflect latest crates
      in rust-vendor/.
    - Remove the following patches, since they are incl. in new upstream:
      - d/p/lp-2098500-scsi_logging_level-Delete-SCSI-logging-script.patch
      - d/p/lp-2098358-s390-tools-Add-zpwr-tool.patch
      - d/p/lp-2098358-zpwr-Add-man-page-for-zpwr-tool.patch
    - Expand and restructure d/s390-tools*.install to cover all Rust tools
      and to add files for command completion.
    - Add quilt patch d/p/fix-64bit-lib-path-handling.patch to fix
      handling of 64bit library path in s390-tools code and config files.
    - Expand d/s390-tools-chreipl-fcp-mpath.install for dracut-related
      config file.
    - Tidy up d/not-installed.

 -- Frank Heimes <frank.heimes@canonical.com>  Tue, 01 Jul 2025 08:12:06 +0200

s390-tools (2.37.0-0ubuntu5) questing; urgency=medium

  * No-change rebuild (LP: #2112166)

 -- Frank Heimes <frank.heimes@canonical.com>  Fri, 30 May 2025 09:39:33 +0200

s390-tools (2.37.0-0ubuntu4) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 20 May 2025 12:21:09 +0200

s390-tools (2.37.0-0ubuntu3) questing; urgency=medium

  * Rebuild against latest fuse3

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 01 May 2025 14:47:48 -0400

=== debian/control ===
Source: s390-tools
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian S/390 Team <debian-s390@lists.debian.org>
Uploaders: Bastian Blank <waldi@debian.org>
Build-Depends:
 bsdextrautils,
 cargo,
 debhelper-compat (= 13),
 dh-cargo-tools,
 dh-exec,
 libcryptsetup-dev,
 libcurl4-openssl-dev,
 libfuse3-dev,
 libglib2.0-dev,
 libjson-c-dev,
 liblockfile-dev,
 libncurses-dev,
 libnl-3-dev,
 libnl-genl-3-dev,
 libnl-route-3-dev,
 libpfm4-dev,
 libsnmp-dev,
 libssl-dev,
 libxml2-dev,
 libz-dev,
 pkgconf,
 quilt
Standards-Version: 4.6.2
Homepage: https://github.com/ibm-s390-linux/s390-tools
XS-Build-Indep-Architecture: s390x
XS-Vendored-Sources-Rust: aho-corasick@1.1.3, anstream@0.6.18, anstyle-parse@0.2.6, anstyle-query@1.1.2, anstyle-wincon@3.0.6, anstyle@1.0.10, anyhow@1.0.95, autocfg@1.4.0, base64@0.22.1, bit-set@0.8.0, bit-vec@0.8.0, bitflags@2.7.0, bitvec@1.0.1, byteorder@1.5.0, cc@1.2.9, cfg-if@1.0.0, clap@4.5.23, clap_builder@4.5.23, clap_complete@4.5.38, clap_derive@4.5.18, clap_lex@0.7.4, colorchoice@1.0.3, curl-sys@0.4.78+curl-8.11.0, curl@0.4.47, darling@0.20.10, darling_core@0.20.10, darling_macro@0.20.10, deku@0.18.1, deku_derive@0.18.1, enum_dispatch@0.3.13, equivalent@1.0.1, errno@0.3.10, fastrand@2.3.0, fnv@1.0.7, foreign-types-shared@0.1.1, foreign-types@0.3.2, funty@2.0.0, getrandom@0.2.16, getrandom@0.3.2, hashbrown@0.12.3, hashbrown@0.15.2, heck@0.5.0, ident_case@1.0.1, indexmap@1.9.3, indexmap@2.6.0, is_terminal_polyfill@1.70.1, itoa@1.0.6, lazy_static@1.5.0, libc@0.2.172, libz-sys@1.1.20, linux-raw-sys@0.4.15, log@0.4.25, memchr@2.7.4, no_std_io2@0.8.1, num-traits@0.2.19, once_cell@1.20.2, openssl-macros@0.1.1, openssl-probe@0.1.5, openssl-sys@0.9.105, openssl@0.10.70, pkg-config@0.3.31, ppv-lite86@0.2.21, proc-macro-crate@3.2.0, proc-macro2@1.0.95, proptest@1.6.0, quick-error@1.2.3, quote@1.0.40, r-efi@5.2.0, radium@0.7.0, rand@0.8.5, rand@0.9.1, rand_chacha@0.3.1, rand_chacha@0.9.0, rand_core@0.6.4, rand_core@0.9.3, rand_xorshift@0.3.0, regex-automata@0.4.9, regex-syntax@0.8.5, regex@1.11.1, rustix@0.38.43, rustversion@1.0.18, rusty-fork@0.3.0, ryu@1.0.13, schannel@0.1.27, serde@1.0.217, serde_derive@1.0.217, serde_json@1.0.99, serde_test@1.0.177, serde_yaml@0.9.21, shlex@1.3.0, socket2@0.5.8, strsim@0.11.1, syn@2.0.101, tap@1.0.1, tempfile@3.15.0, terminal_size@0.4.0, thiserror-impl@2.0.11, thiserror@2.0.11, toml_datetime@0.6.8, toml_edit@0.22.22, unarray@0.1.4, unicode-ident@1.0.18, unsafe-libyaml@0.2.8, utf8parse@0.2.2, vcpkg@0.2.15, wait-timeout@0.2.0, wasi@0.11.0+wasi-snapshot-preview1, wasi@0.14.2+wasi-0.2.4, winnow@0.6.20, wit-bindgen-rt@0.39.0, wyz@0.5.1, zerocopy-derive@0.8.25, zerocopy@0.8.25

Package: s390-tools
Architecture: s390x amd64 ppc64el arm64
Priority: important
Depends:
 gawk [s390x],
 s390-tools-data,
 udev [s390x],
 ${misc:Depends},
 ${perl:Depends},
 ${shlibs:Depends},
 ${signing:Depends}
Recommends: sg3-utils [s390x]
Suggests:
 blktrace [s390x],
 lsscsi [s390x],
 mdevctl [s390x],
 multipath-tools [s390x],
 rsync [s390x],
 s390-tools-chreipl-fcp-mpath [s390x],
 s390-tools-cpuplugd [s390x],
 s390-tools-osasnmpd [s390x],
 s390-tools-statd [s390x]
Description: fundamental utilities for Linux on z Systems
 The package contains:
  * dasdfmt, which is used to low-level format ECKD-DASDs with either
    the classic disk layout or the new zSeries compatible disk layout.
  * dasdview, which is used to display DASD and VTOC information or to
    dump the contents of a DASD to the console.
  * fdasd, which is used to create or modify partitions on ECKD-DASDs
    formatted with the zSeries compatible disk layout.
  * zipl, which is used to make either dasds or tapes bootable for
    system IPL or system dump.
  * zgetdump, which is used to retrieve system dumps from either tapes
    or dasds.
  * hsavmcore, which is used to make the dump process with kdump more
    efficient.
  * lshwc, which is used to extract and list complete counter sets

Package: s390-tools-cpuplugd
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: cpuplugd utility for Linux on z Systems
 The package contains cpuplugd hotplug daemon from the s390-tools
 collection of utilities.

Package: s390-tools-statd
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: s390-tools (<<1.34.0-0ubuntu7~)
Replaces: s390-tools (<<1.34.0-0ubuntu7~)
Description: mon_statd monitoring daemons for Linux on z Systems
 The package contains mon_procd and mon_fsstatd z/VM monitoring
 daemons for Linux on z Systems from the s390-tools collection of
 utilities. These tools are also known as mon_statd.

Package: s390-tools-osasnmpd
Architecture: s390x
Depends: udev, ${misc:Depends}, ${shlibs:Depends}
Description: osasnmpd utility for Linux on z Systems
 The package contains osasnmpd monitoring daemon from the s390-tools
 collection of utilities.

Package: s390-tools-zkey
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: zkey utilities for Linux on z Systems
 The package contains zkey and zkey-cryptsetup from the s390-tools
 collection of utilities.

Package: libekmfweb1
Section: libs
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: integration with IBM Enterprise Key Management Foundation
 This package contains library to integrate with IBM Enterprise Key
 Management Foundation. It is used by zkey plugin for pervasive
 encryption support.
 .
 This package contains the runtime library.

Package: libekmfweb-dev
Section: libdevel
Architecture: s390x
Depends: ${misc:Depends}
Description: integration with IBM Enterprise Key Management Foundation (development)
 This package contains library to integrate with IBM Enterprise Key
 Management Foundation. It is used by zkey plugin for pervasive
 encryption support.
 .
 This package contains the development library and headers.

Package: libkmipclient1
Section: libs
Architecture: s390x
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: KMIP client library
 A shared library that provides an KMIP client to communicate with an KMIP
 server. KMIP stands for Key Management Interoperability Protocol, and is an
 extensible communication protocol that defines message formats for the
 manipulation of cryptographic keys on a key management server.
 .
 This package contains the runtime library.

Package: libkmipclient-dev
Section: libdevel
Architecture: s390x
Depends: ${misc:Depends}
Description: KMIP client library (development)
 A shared library that provides an KMIP client to communicate with an KMIP
 server. KMIP stands for Key Management Interoperability Protocol, and is an
 extensible communication protocol that defines message formats for the
 manipulation of cryptographic keys on a key management server.
 .
 This package contains the development library and headers

Package: s390-tools-chreipl-fcp-mpath
Architecture: s390x
Depends: multipath-tools, multipath-tools-boot, udev, ${misc:Depends}
Description: chreipl-fcp-mpath utility for Linux on z Systems
 The package contains chreipl-fcp-mpath toolset from the s390-tools collection
 of utilities, that uses multipath information to change the configured FCP
 re-IPL path on detecting issues with the current path.

Package: s390-tools-data
Architecture: all
Depends: ${misc:Depends}
Replaces: s390-tools (<< 2.28.0-0ubuntu2)
Breaks: s390-tools (<< 2.28.0-0ubuntu2)
Description: fundamental utilities for Linux on z Systems (data files)
 Host architecture independent files used by s390-tools utilities for
 z Systems. Currently this package ships stage3a/b files for genprotimg.

## s390-tools 2.39.0

=== iucvterm/doc/Makefile ===
#! /usr/bin/make -f

include ../../common.mak

MANS = iucvconn.1 iucvtty.1 ts-shell.1 hvc_iucv.9 chiucvallow.8 ttyrun.8

all:

check:

install: install-man

install-man: $(MANS)
	for man in $(MANS); do \
	  msection=`echo $$man |sed 's/.*\.\([1-9]\)$$/man\1/'` ; \
	  $(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 -D $$man $(DESTDIR)$(MANDIR)/$$msection/$$man ; \
	done
	ln -f -s chiucvallow.8 $(DESTDIR)$(MANDIR)/man8/lsiucvallow.8

clean:

pdf: $(MANS)
	for man in $(MANS); do \
	  man -t ./$$man |ps2pdf -sPAPERSIZE=a4 - $${man}.pdf ; \
	done


.PHONY: install-man install clean pdf

=== rust/pvimg/boot/Makefile ===
# Common definitions
include ../../../common.mak

FILES := stage3a.bin stage3b.bin stage3b_reloc.bin
DEBUG_FILES := $(addsuffix .debug,$(FILES))

ifeq ($(HOST_ARCH),s390x)
ZIPL_DIR := $(rootdir)/zipl
ZIPL_BOOT_DIR := $(ZIPL_DIR)/boot
PVIMG_PKGDATADIR ?= $(TOOLS_DATADIR)/pvimg

INCLUDE_PATHS := $(ZIPL_BOOT_DIR) $(ZIPL_DIR)/include $(rootdir)/include
INCLUDE_PARMS := $(addprefix -I,$(INCLUDE_PATHS))

ALL_CFLAGS := $(NO_PIE_CFLAGS) -Os -g \
	$(INCLUDE_PARMS) \
	-DENABLE_SCLP_ASCII=1 \
	-DS390_TOOLS_RELEASE=$(S390_TOOLS_RELEASE) \
	-fno-builtin -ffreestanding -fno-asynchronous-unwind-tables \
	-fno-delete-null-pointer-checks -fno-stack-protector \
	-fexec-charset=IBM1047 -m64 -mpacked-stack \
	-mstack-size=4096 -mstack-guard=128 -msoft-float \
	-Wall -Wformat-security -Wextra \
	-Wno-array-bounds

ZIPL_SRCS_C := libc.c ebcdic.c ebcdic_conv.c sclp.c
ZIPL_SRCS_ASM := entry.S

ZIPL_OBJS_C := $(ZIPL_SRCS_C:%.c=%.o)
ZIPL_OBJS_ASM := $(ZIPL_SRCS_ASM:%.S=%.o)
ZIPL_OBJS := $(ZIPL_OBJS_C) $(ZIPL_OBJS_ASM)

# Prevent make from using some default rules...
%:	%.S

%.o:	%.S Makefile
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

%.o:	%.c Makefile
	$(CC) $(ALL_CFLAGS) -c -o $@ $<


# Dependencies for the .lds generation
sources_lds_S = $(wildcard *.lds.S)
dependencies_lds_S = $(sources_lds_S:%.lds.S=.%.lds.d)
# Include all ".lds.d" dependency files for all make targets except for "clean"
ifneq ($(MAKECMDGOALS),clean)
-include $(dependencies_lds_S)
endif

%.lds:	%.lds.S Makefile
	$(CPP) -Wp,-MD,.$@.d,-MT,$@ $(INCLUDE_PARMS) -P -C -o $@ $<

# Special rules for zipl object files
$(ZIPL_OBJS_C): %.o : $(ZIPL_BOOT_DIR)/%.c
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

$(ZIPL_OBJS_ASM): %.o : $(ZIPL_BOOT_DIR)/%.S
	$(CC) $(ALL_CFLAGS) -c -o $@ $<

dependencies_zipl_c := $(ZIPL_SRCS_C:%.c=.%.o.d)

$(dependencies_zipl_c): .%.o.d : $(ZIPL_BOOT_DIR)/%.c
	$(CC_SILENT) -MM $(ALL_CPPFLAGS) $(ALL_CFLAGS) $< > $@

ifneq ($(MAKECMDGOALS),clean)
-include $(dependencies_zipl_c)
endif

stage3b_reloc.o: stage3b.bin

stage3a.elf: head.o stage3a_init.o $(ZIPL_OBJS)
stage3b.elf: head.o $(ZIPL_OBJS)

.SECONDARY: $(FILES:.bin=.lds)
%.elf: %.lds %.o
	$(LINK) $(NO_PIE_LDFLAGS) $(NO_WARN_RWX_SEGMENTS_LDFLAGS) -Wl,-T,$< -Wl,--build-id=none -m64 -static -nostdlib $(filter %.o, $^) -o $@
	@chmod a-x $@

%.bin.debug: %.elf
	$(OBJCOPY) --only-keep-debug $< $@
	@chmod a-x $@

%.bin: %.elf
	$(OBJCOPY) -O binary $< $@
	@chmod a-x $@

install: stage3a.bin stage3b_reloc.bin
	$(INSTALL) -d -m 755 $(DESTDIR)$(PVIMG_PKGDATADIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 stage3a.bin $(DESTDIR)$(PVIMG_PKGDATADIR)
	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 stage3b_reloc.bin $(DESTDIR)$(PVIMG_PKGDATADIR)

else
# Don't generate the dependency files (see `common.mak` for the
# `-include $(dependencies_c)` statement).
.PHONY: $(dependencies_c)

$(FILES) $(DEBUG_FILES):
	echo "  SKIP    $@ due to HOST_ARCH != s390x"

install:
	echo "  SKIP    Bootloader installation due to HOST_ARCH != s390x"
endif

.DEFAULT_GOAL := all
all: $(FILES) $(DEBUG_FILES)

clean:
	rm -f -- *.o *.elf *.bin *.map .*.d *.lds *.debug

.PHONY: all clean

=== debian/changelog ===
s390-tools (2.39.0-0ubuntu1) resolute; urgency=medium

  * New upstream release. (LP: #2133937)
    - Refresh d/p/install-iucvterm.patch to remove fuzz.
    - Update d/p/vendor-remove-unused-deps.patch to reflect latest crates
      in rust-vendor/.
    - Remove d/p/debian/patches/lp-2118866-cpi-Disable-CPI-for-SEL-*.patch
      since it's already incl. in new upstream version.
    - Update XS-Vendored-Sources-Rust field in d/control with new/different
      crates/versions.

 -- Frank Heimes <frank.heimes@canonical.com>  Fri, 05 Dec 2025 11:47:11 +0100

=== debian/control ===
--- 
+++ 
@@ -30,7 +30,7 @@
 Standards-Version: 4.6.2
 Homepage: https://github.com/ibm-s390-linux/s390-tools
 XS-Build-Indep-Architecture: s390x
-XS-Vendored-Sources-Rust: aho-corasick@1.1.3, anstream@0.6.18, anstyle-parse@0.2.6, anstyle-query@1.1.2, anstyle-wincon@3.0.6, anstyle@1.0.10, anyhow@1.0.95, autocfg@1.4.0, base64@0.22.1, bit-set@0.8.0, bit-vec@0.8.0, bitflags@2.7.0, bitvec@1.0.1, byteorder@1.5.0, cc@1.2.9, cfg-if@1.0.0, clap@4.5.23, clap_builder@4.5.23, clap_complete@4.5.38, clap_derive@4.5.18, clap_lex@0.7.4, colorchoice@1.0.3, curl-sys@0.4.78+curl-8.11.0, curl@0.4.47, darling@0.20.10, darling_core@0.20.10, darling_macro@0.20.10, deku@0.18.1, deku_derive@0.18.1, enum_dispatch@0.3.13, equivalent@1.0.1, errno@0.3.10, fastrand@2.3.0, fnv@1.0.7, foreign-types-shared@0.1.1, foreign-types@0.3.2, funty@2.0.0, getrandom@0.2.16, getrandom@0.3.2, hashbrown@0.12.3, hashbrown@0.15.2, heck@0.5.0, ident_case@1.0.1, indexmap@1.9.3, indexmap@2.6.0, is_terminal_polyfill@1.70.1, itoa@1.0.6, lazy_static@1.5.0, libc@0.2.172, libz-sys@1.1.20, linux-raw-sys@0.4.15, log@0.4.25, memchr@2.7.4, no_std_io2@0.8.1, num-traits@0.2.19, once_cell@1.20.2, openssl-macros@0.1.1, openssl-probe@0.1.5, openssl-sys@0.9.105, openssl@0.10.70, pkg-config@0.3.31, ppv-lite86@0.2.21, proc-macro-crate@3.2.0, proc-macro2@1.0.95, proptest@1.6.0, quick-error@1.2.3, quote@1.0.40, r-efi@5.2.0, radium@0.7.0, rand@0.8.5, rand@0.9.1, rand_chacha@0.3.1, rand_chacha@0.9.0, rand_core@0.6.4, rand_core@0.9.3, rand_xorshift@0.3.0, regex-automata@0.4.9, regex-syntax@0.8.5, regex@1.11.1, rustix@0.38.43, rustversion@1.0.18, rusty-fork@0.3.0, ryu@1.0.13, schannel@0.1.27, serde@1.0.217, serde_derive@1.0.217, serde_json@1.0.99, serde_test@1.0.177, serde_yaml@0.9.21, shlex@1.3.0, socket2@0.5.8, strsim@0.11.1, syn@2.0.101, tap@1.0.1, tempfile@3.15.0, terminal_size@0.4.0, thiserror-impl@2.0.11, thiserror@2.0.11, toml_datetime@0.6.8, toml_edit@0.22.22, unarray@0.1.4, unicode-ident@1.0.18, unsafe-libyaml@0.2.8, utf8parse@0.2.2, vcpkg@0.2.15, wait-timeout@0.2.0, wasi@0.11.0+wasi-snapshot-preview1, wasi@0.14.2+wasi-0.2.4, winnow@0.6.20, wit-bindgen-rt@0.39.0, wyz@0.5.1, zerocopy-derive@0.8.25, zerocopy@0.8.25
+XS-Vendored-Sources-Rust: aho-corasick@1.1.3, anstream@0.6.18, anstyle-parse@0.2.6, anstyle-query@1.1.2, anstyle-wincon@3.0.6, anstyle@1.0.10, anyhow@1.0.95, autocfg@1.4.0, base64@0.22.1, bit-set@0.8.0, bit-vec@0.8.0, bitflags@2.7.0, bitvec@1.0.1, byteorder@1.5.0, cc@1.2.9, cfg-if@1.0.0, clap@4.5.23, clap_builder@4.5.23, clap_complete@4.5.38, clap_derive@4.5.18, clap_lex@0.7.4, colorchoice@1.0.3, curl-sys@0.4.83+curl-8.15.0, curl@0.4.49, darling@0.20.10, darling_core@0.20.10, darling_macro@0.20.10, deku@0.18.1, deku_derive@0.18.1, enum_dispatch@0.3.13, equivalent@1.0.1, errno@0.3.10, fastrand@2.3.0, fnv@1.0.7, foreign-types-shared@0.1.1, foreign-types@0.3.2, funty@2.0.0, getrandom@0.2.16, getrandom@0.3.2, hashbrown@0.12.3, hashbrown@0.15.2, heck@0.5.0, ident_case@1.0.1, indexmap@1.9.3, indexmap@2.6.0, is_terminal_polyfill@1.70.1, itoa@1.0.6, lazy_static@1.5.0, libc@0.2.172, libz-sys@1.1.20, linux-raw-sys@0.4.15, log@0.4.25, memchr@2.7.4, no_std_io2@0.8.1, num-traits@0.2.19, once_cell@1.20.2, openssl-macros@0.1.1, openssl-probe@0.1.5, openssl-sys@0.9.109, openssl@0.10.73, pkg-config@0.3.31, ppv-lite86@0.2.21, proc-macro-crate@3.2.0, proc-macro2@1.0.95, proptest@1.6.0, quick-error@1.2.3, quote@1.0.40, r-efi@5.2.0, radium@0.7.0, rand@0.8.5, rand@0.9.1, rand_chacha@0.3.1, rand_chacha@0.9.0, rand_core@0.6.4, rand_core@0.9.3, rand_xorshift@0.3.0, regex-automata@0.4.9, regex-syntax@0.8.5, regex@1.11.1, rustix@0.38.43, rustversion@1.0.18, rusty-fork@0.3.0, ryu@1.0.13, schannel@0.1.27, serde@1.0.217, serde_derive@1.0.217, serde_json@1.0.99, serde_test@1.0.177, serde_yaml@0.9.21, shlex@1.3.0, socket2@0.6.0, strsim@0.11.1, syn@2.0.101, tap@1.0.1, tempfile@3.15.0, terminal_size@0.4.0, thiserror-impl@2.0.11, thiserror@2.0.11, toml_datetime@0.6.8, toml_edit@0.22.22, unarray@0.1.4, unicode-ident@1.0.18, unsafe-libyaml@0.2.11, utf8parse@0.2.2, vcpkg@0.2.15, wait-timeout@0.2.0, wasi@0.11.0+wasi-snapshot-preview1, wasi@0.14.2+wasi-0.2.4, winnow@0.6.20, wit-bindgen-rt@0.39.0, wyz@0.5.1, zerocopy-derive@0.8.25, zerocopy@0.8.25
 
 Package: s390-tools
 Architecture: s390x amd64 ppc64el arm64
